<?php

declare(strict_types=1);

namespace mirzaev\huesos\models\traits;

// Built-in libraries
use exception;

/**
 * Trait for initialization of a status
 *
 * @package mirzaev\huesos\models\traits
 *
 * @license http://www.wtfpl.net/ Do What The Fuck You Want To Public License
 * @author Arsen Mirzaev Tatyano-Muradovich <arsen@mirzaev.sexy>
 */
trait status
{
	/**
	 * Initialize of a status
	 *
	 * @param array &$errors Registry of errors
	 *
	 * @return ?bool Status, if they are found
	 */
	public function status(array &$errors = []): ?bool
	{
		try {
			// Read from ArangoDB and exit (success)
			return $this->document->active ?? false;
		} catch (exception $e) {
			// Writing to the registry of errors
			$errors[] = [
				'text' => $e->getMessage(),
				'file' => $e->getFile(),
				'line' => $e->getLine(),
				'stack' => $e->getTrace()
			];
		}

		// Exit (fail)
		return null;
	}
}

